import QtQuick
import QtQuick.Window
import QtPositioning

Window {
    width: 640
    height: 480
    visible: true
    title: qsTr("Hello World")

    PositionSource {
        id: posSource
        updateInterval: 0
        name: (Qt.platform.os === "android") ? "android" : "corelocation"

        onPositionChanged: {
            console.log("coordinate:", posSource.position.coordinate)
            console.log("direction:", posSource.position.direction, "valid:", posSource.position.directionValid)
            console.log("directionAccuracy:", posSource.position.directionAccuracy, "valid:", posSource.position.directionAccuracyValid)
        }
        Component.onCompleted: {
            console.log("Created position source for", posSource.name)
        }
        onSourceErrorChanged: {
            console.log("Received source error:", posSource.sourceError)
        }
    }

    property bool __start: true

    Column {
        anchors.centerIn: parent
        spacing: 20
        Button {
            id: startStop
            text: "Start/Stop"
            onClicked: {
                if (__start) {
                    posSource.start()
                    console.log("started")
                } else {
                    posSource.stop()
                    console.log("stopped")
                }
                __start = !__start
            }
        }
        Text {
            text: __start ? "stopped" : "started"
        }
        Text {
            text: "coordinate: " + posSource.position.coordinate
        }
        Text {
            text: "direction: " + posSource.position.direction + "; valid: " +
                  posSource.position.directionValid
        }
        Text {
            text: "directionAccuracy: " + posSource.position.directionAccuracy +
                  "; valid: " + posSource.position.directionAccuracyValid
        }
    }
}
